/**
 * Dragon - SOA Governance Platform.
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * PostManagerServiceImpl.java
 * -------------------------------------------------------------------------
 */

package org.ow2.dragon.service.organization;

import java.util.List;

import javax.jws.WebService;

import org.ow2.dragon.api.service.organization.OrganizationException;
import org.ow2.dragon.api.service.organization.PostManager;
import org.ow2.dragon.api.to.RequestOptionsTO;
import org.ow2.dragon.api.to.organization.PostTO;
import org.ow2.dragon.service.DragonFault;

/**
 * @author ofabre
 * 
 */
@WebService(endpointInterface = "org.ow2.dragon.service.organization.PostManagerService")
public class PostManagerServiceImpl implements PostManagerService {

    private PostManager postManager;

    public void setPostManager(PostManager postManager) {
        this.postManager = postManager;
    }

    public String createPost(PostTO postTO) throws DragonFault {
        try {
            return postManager.createPost(postTO);
        } catch (OrganizationException e) {
            throw new DragonFault(e.getMessage(), e);
        }
    }

    public List<PostTO> getAllPosts(RequestOptionsTO requestOptionsTO) {
        return postManager.getAllPosts(requestOptionsTO);
    }

    public PostTO getPost(String postId) throws DragonFault {
        try {
            return postManager.getPost(postId);
        } catch (OrganizationException e) {
            throw new DragonFault(e.getMessage(), e);
        }
    }

    public void removePost(String postId) throws DragonFault {
        try {
            postManager.removePost(postId);
        } catch (OrganizationException e) {
            throw new DragonFault(e.getMessage(), e);
        }
    }

}
